include l4pre 


  Copyright GMD, L4.SMALLS.5, 11 07 96, 12
 
 
;*********************************************************************
;******                                                         ******
;******         Small Address Space Handler                     ******
;******                                                         ******
;******                                   Author:   J.Liedtke   ******
;******                                                         ******
;******                                   created:  24.02.95    ******
;******                                   modified: 11.07.96    ******
;******                                                         ******
;*********************************************************************
 

  public init_small_address_spaces
  public attach_small_space
  public detach_small_space
  public update_small_pde

 

include l4const
include adrspace
include uid
include tcb
include cpucb
include schedcb
include intrifc
include pagconst
include pagmac
include pagcb



ok_for pentium



  assume ds:codseg





 
;----------------------------------------------------------------------------
;
;       init small address spaces
;
;----------------------------------------------------------------------------
; PRECONDITION:
;
;       DS     linear kernel space
;
;       paging enabled
;
;----------------------------------------------------------------------------


  icode



init_small_address_spaces:


  mov   ebx,1
  DO
        mov   byte ptr ds:[ebx*2+small_associated_task-2],bl
        inc   ebx
        cmp   ebx,small_spaces
        REPEATB
  OD
  mov   byte ptr ds:[small_associated_task+(small_spaces-1)*2],0FFh
  mov   ds:[next_small_space],0

  ret


 


  icod ends




;----------------------------------------------------------------------------
;
;       attach small space
;
;----------------------------------------------------------------------------
; PRECONDITION:
;
;       EDX   task no
;
;       DS    linear kernel space
;
;----------------------------------------------------------------------------




attach_small_space:

  push  eax
  push  ebx

  sub   ebx,ebx
  mov   bl,ds:[next_small_space]
  IFNZ  bl,0FFh

        mov   eax,edx
        xchg  ax,ds:[(ebx*2)+small_associated_task]
        mov   ds:[next_small_space],al

        shl   ebx,22-16
        add   ebx,offset small_virtual_spaces SHR 16
        xchg  bl,bh
        ror   ebx,8
        add   ebx,00C0F300h
        mov   [edx*8+task_proot],ebx

        mov   eax,[edx*8+task_proot+4]
        mov   eax,[eax+PM]
        call  update_small_pde

  FI

  pop   ebx
  pop   eax
  ret





;----------------------------------------------------------------------------
;
;       detach small space
;
;----------------------------------------------------------------------------
; PRECONDITION:
;
;       EDX   task no
;
;       DS    linear kernel space
;
;----------------------------------------------------------------------------




detach_small_space:

  push  eax
  push  ebx

  sub   eax,eax
  call  update_small_pde

  IFC
        mov   al,bl
        xchg  al,ds:[next_small_space]
        mov   byte ptr ds:[ebx*2+small_associated_task],al
  FI

  pop   ebx
  pop   eax
  ret




;----------------------------------------------------------------------------
;
;       update small page directory entry
;
;----------------------------------------------------------------------------
; PRECONDITION:
;
;       EAX   new pde
;       EDX   task no
;
;       DS    linear kernel space
;
;----------------------------------------------------------------------------
; POSTCONDITION:
;
;       C:    EBX   associated small space no
;
;       NC:   no small space associated, EBX undefined
;
;----------------------------------------------------------------------------



update_small_pde:

  mov   ebx,[edx*8+task_proot]
  test  ebx,ebx
  IFS
        rol   ebx,8
        xchg  bl,bh
        sub   ebx,offset small_virtual_spaces SHR 16
        shr   ebx,22-16
        movzx ebx,bl
 
        push  esi
        push  edi

        mov   edi,ds:[kernel_proot]
        IFNZ  <dword ptr ds:[(ebx*4)+edi+(offset small_virtual_spaces SHR (22-2))+PM]>,0
              mov   esi,cr3
              mov   cr3,esi
        FI

        mov   esi,offset task_proot+4
        DO
              mov   edi,[esi]
              add   esi,4
              test  edi,edi
              EXITS
              REPEATZ

              mov   [(ebx*4)+edi+(offset small_virtual_spaces SHR (22-2))+PM],eax
              REPEAT
        OD

        pop   edi
        pop   esi

        stc
  FI

  ret






  code ends
  end