include l4pre 
 
dresden equ false


  Copyright GMD, L4.START, 02 06 96, 27
 
;*********************************************************************
;******                                                         ******
;******         System Start                                    ******
;******                                                         ******
;******                                   Author:   J.Liedtke   ******
;******                                                         ******
;******                                   created:  04.03.91    ******
;******                                   modified: 02.06.96    ******
;******                                                         ******
;*********************************************************************
 
 
  public kernel_start

  extrn  init_default_kdebug:near,default_kdebug_exception:near
  extrn  default_kdebug_end:byte
  extrn  default_sigma0_stack:dword,default_sigma0_start:near
  extrn  default_sigma0_begin:byte,default_sigma0_end:byte
  extrn  default_sigma1_stack:dword,default_sigma1_start:near
  extrn  default_sigma1_begin:byte,default_sigma1_end:byte
  extrn  ktest0_stack:dword,ktest0_start:near
  extrn  ktest1_stack:dword,ktest1_start:near
  extrn  ktest_begin:byte,ktest_end:byte
  extrn  labseg_start:byte
  extrn  kernelstring:byte
  extrn  kernelver:abs
  extrn  physical_kernel_info_page:abs


  extrn init_memctr:near
  extrn enable_paging_mode:near
  extrn init_sgmctr:near
  extrn init_intctr:near
  extrn init_pagmap:near
  extrn init_fresh_frame_pool:near
  extrn init_pagfault:near
  extrn init_schedcb:near
  extrn init_cpuctr:near
  extrn init_tcbman:near
  extrn init_dispatcher:near
  extrn init_ipcman:near
  extrn init_adrsman:near
  extrn init_emuctr:near
  extrn init_basic_hw_interrupts:near
  extrn init_sigma0_1:near
  extrn start_dispatch:near
  extrn ptabman_start:near
  extrn create_kernel_thread:near
  extrn create_kernel_including_task:near
  extrn kcod_start:near




 
include l4const
include l4kd
include adrspace
include uid
include tcb
include syscalls
include kpage


ok_for 486,pentium,ppro

 
 
;*********************************************************************
;******                                                         ******
;******         System Start                                    ******
;******                                                         ******
;******                                                         ******
;*********************************************************************
 
 
 
  strtseg


;----------------------------------------------------------------------------
;
;       link table
;
;----------------------------------------------------------------------------
;
;       In the strt segment, *only* the start code of
;       module start.pc is located before this table.
;
;       Start.pc *MUST* ensure that it occupies position
;       0 ... 100X ( 0 < X < 10h ) so that the following
;       table is placed at location 1010h (becaus 16-byte align).
;
;----------------------------------------------------------------------------


  dd    init_default_kdebug,default_kdebug_exception ; 1010 ; kdebug
  dd    0,default_kdebug_end

  dd    default_sigma0_stack,default_sigma0_start    ; 1020 ; sigma0 ESP, EIP
  dd    default_sigma0_begin,default_sigma0_end

  dd    default_sigma1_stack,default_sigma1_start    ; 1030 ; sigma1 ESP, EIP
  dd    default_sigma1_begin,default_sigma1_end

  IF    dresden
        dd    6*MB1,MB1+20h                          ; 1040 ; booter ESP, EIP
        dd    MB1,1B0000h
        dd    0,0                                    ; 1050 ; sigma2 ESP, EIP
        dd    0,0
  ELSE
        dd    ktest0_stack,ktest0_start              ; 1040 ; booter ESP, EIP
        dd    ktest_begin,ktest_end
        dd    ktest1_stack,ktest1_start              ; 1050 ; sigma2 ESP, EIP
        dd    ktest_begin,ktest_end
  ENDIF

  dd    0,0           ; main_mem                     ; 1060
  dd    0,0           ; reserved_mem0 

  dd    0,0           ; reserved_mem1                ; 1070
  dd    0,0           ; dedicated_mem0 

  IF    dresden
        dd    MB1,6*MB1;dedicated_mem1               ; 1080
  ELSE
        dd    0,0     ; dedicated_mem1               ; 1080
  ENDIF

  dd    0,0           ; dedicated_mem2 

  dd    0,0           ; dedicated_mem3               ; 1090
  dd    0,0           ; dedicated_mem4 

  dd    0,0,0,0                                      ; 10A0 ; user clock

  strt ends



;---------------------------------------------------------------------
;
;       system start
;
;---------------------------------------------------------------------
; PRECONDITION:
;
;       protected mode
;
;       CS    executable & readable segment, starting at 0, size 4G
;             USE32
;       DS    readable & writable segment, starting at 0, size 4G
;
;       interrupts disabled
;
;---------------------------------------------------------------------
 
 assume ds:codseg
 

  icode

 
kernel_start:
 
  mov   ax,ds
  mov   es,ax
  mov   fs,ax
  mov   gs,ax
  mov   ss,ax


  mov   edi,physical_kernel_info_page

  mov   [edi+L4_magic_word],4BE6344Ch     ;  'L4',0E6h,'K'
  mov   [edi+L4_version_word],kernelver
  mov   eax,offset labseg_start
  sub   eax,edi
  shr   eax,4
  mov   [edi+L4_label_link],al


  call  cs:[init_kdebug+physical_kernel_info_page]
  call  init_memctr
  call  enable_paging_mode
  call  init_sgmctr
  call  init_intctr

  kd____clear_page
  mov   al,0
  mov   ah,22
  kd____cursor

  mov   eax,offset kernelstring
  kd____outcstring
  kd____disp <13,10,10>

  call  init_cpuctr
  call  init_pagfault
  call  init_pagmap
  call  init_fresh_frame_pool
  call  init_schedcb
  call  init_tcbman
  call  init_dispatcher
  call  init_ipcman
  call  init_adrsman
  call  init_emuctr
  call  init_basic_hw_interrupts

  ke    'debug'

  cli


  call  init_sigma0_1


  mov   eax,booter_task
  lea   ebx,ds:[booter_ktask+physical_kernel_info_page+PM]
  call  create_kernel_including_task

  IFZ   ds:[booter_ktask+physical_kernel_info_page+PM].ktask_start,<offset ktest0_start>
        mov   eax,sigma2_task
        lea   ebx,ds:[sigma2_ktask+physical_kernel_info_page+PM]
  CANDNZ <[ebx].ktask_stack>,0
        call  create_kernel_including_task
  FI

  jmp   ptabman_start


  icod  ends



  code ends
  end